#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

/* Qualche sano define per una nota di colore */
#define FOWD  1
#define BACK -1

#define STEPX 20
#define STEPY 20

#define RUN_FREQ   33
#define RUN_STEPX  10
#define RUN_STEPY  10

gint Timer = 0, dir = FOWD;

/* Queste variabili sono per la gestione della posizione dei pinguini
 * Sarebbe bene fare un files con le sole funzione di gestione e limitare 
 * lo scope di queste variabili a quel file. Visto pero` che lintero
 * callbacks non si occupa di altro che non di pinguini... non serve ;)
 */

const char * nomi[4] = {"penguin1", "penguin2", "penguin3", "penguin4"};
const int init_px[4] = {0, 24, 48, 72}, init_py[4] = {26, 10, 12, 24};
int Npeng = 3, n = 0, new = 1, Freq = RUN_FREQ;
int posx = 64, posy = 40;
int stepx = 20, stepy = 0;


void
on_step_pressed                        (GtkButton       *button,
                                        gpointer         user_data)
{
 char buf[120];
 GtkWidget * peng, * text  = NULL;
 
 if(Timer && dir == BACK)
 {
  /* Smette di correre indietro */
  on_run_toggled( NULL, NULL );
  
  /* e comincia nellaltro verso */
  dir = FOWD;
  on_run_toggled( NULL, NULL );
   
  /* Nessuno disturbi la sua corsa */
  return;
 } 
 dir = FOWD;

 if(Npeng < 0)
 {
  if(Timer)
  { 
   /* Rialza il bottone e il segnale di toggle ferma il timer */
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON ( lookup_widget(Base, "run") ), FALSE); 
  } 
  return;
 } 
 else
 {
  peng = lookup_widget(Base, nomi[Npeng]);
  new = 0;
  n++;
 }

 if(text == NULL)
  text = lookup_widget(Base, "testo");
 
 if(posx >= 524)
 {
  stepx =  0;
  stepy = (Timer) ? RUN_STEPY : STEPY;
 }
  
 if(posy >= 140)
 {
  stepx = -((Timer) ? RUN_STEPX : STEPX);
  stepy = 0;
  if(posx <= 160)
  {
   posx -= 10;
   posy += 10;
   gtk_widget_set_uposition (peng, posx, posy);
   posx = 64; 
   posy = 40;
   stepx = (Timer) ? RUN_STEPX : STEPX; 
   stepy = 0;
   Npeng--;
   new = 1;
   return;
  }
 }
 
 posx += stepx;
 posy += stepy;

 sprintf(buf, "\n%3d] %s pos is %3d, %3d (%d,%d)", n, nomi[Npeng], posx, posy, stepx, stepy);
 gtk_text_insert (GTK_TEXT (text), gdk_fontset_load("*fixed*") , NULL, NULL, buf, -1);
 gtk_widget_set_uposition (peng, posx, posy);

 return;
}


void
on_base_destroy                        (GtkObject       *object,
                                        gpointer         user_data)
{
 /* Sempre meglio avere una sola 
  * funzione che si occupa di 
  * uscire in modo pulito
  */
 on_exit_released(NULL, NULL);
}


void
on_restart_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
 char buf[120];
 GtkWidget * peng, * text  = NULL;

 dir=FOWD;
 new = 1, n = 1;
 posx = 64; posy = 40;
 stepx = 20; stepy = 0;
 
 n++;
 if(text == NULL)
  text = lookup_widget(Base, "testo");
 sprintf(buf, "\n\n -= All penguins return to home =-\n");
 gtk_text_insert (GTK_TEXT (text), gdk_fontset_load("*fixed*") , NULL, NULL, buf, -1);

 for(Npeng = 0; Npeng < 4; Npeng++)
 {
  peng = lookup_widget(Base, nomi[Npeng]);
  gtk_widget_set_uposition (peng, init_px[Npeng], init_py[Npeng]);
 }
 Npeng = 3;
 
 return;
}


void
on_exit_released                       (GtkButton       *button,
                                        gpointer         user_data)
{
 g_print("\n");

 if(Timer != 0)
  gtk_timeout_remove(Timer);

 gtk_exit(0);
}


void
on_back_pressed                        (GtkButton       *button,
                                        gpointer         user_data)
{
 char buf[120];
 GtkWidget * peng, * text  = NULL;

 if(Timer && dir == FOWD)
 {
  /* Smette di correre indietro */
  on_run_toggled( NULL, NULL );
  
  /* e comincia nellaltro verso */
  dir = BACK;
  on_run_toggled( NULL, NULL );
   
  /* Nessuno disturbi la sua corsa */
  return;
 } 
 dir = BACK;

 if(Npeng < 0 || new)
  return;
 else
 {
  peng = lookup_widget(Base, nomi[Npeng]);
  n++;
 }

 if(text == NULL)
  text = lookup_widget(Base, "testo");
 

 if(posx < 524)
 {
  if(posx < 60)
  { 
   new = 1;
   dir = FOWD;   
   if(Timer) 
   { 
    /* Rialza il bottone e il segnale di toggle ferma il timer */
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON ( lookup_widget(Base, "run") ), FALSE); 
   } 
  
   return;
  }
  else
  { 
   if(posy > 40)
   {
    if(posx <= 140)
    {
     new = 1;
     dir = FOWD;
     if(Timer) 
     { 
      /* Rialza il bottone e il segnale di toggle ferma il timer */
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON ( lookup_widget(Base, "run") ), FALSE); 
     } 
     return;
    }
    else
    {
     stepx = -((Timer) ? RUN_STEPX : STEPX);
     stepy = 0;
    } 
   }
   else
   {
    stepx = (Timer) ? RUN_STEPY : STEPY;
    stepy = 0;
   } 
  } 
 }
 else
 {
  if(posy > 40)
  {
   stepx = 0;
   stepy = (Timer) ? RUN_STEPX : STEPX;
  }
  else
  {
   stepx = (Timer) ? RUN_STEPY : STEPY;
   stepy = 0;
  }
 }
  
 posx -= stepx;
 posy -= stepy;

 sprintf(buf, "\n%3d] %s pos is %3d, %3d", n, nomi[Npeng], posx, posy);
 gtk_text_insert (GTK_TEXT (text), gdk_fontset_load("*fixed*") , NULL, NULL, buf, -1);
 gtk_widget_set_uposition (peng, posx, posy);

 return;
}


void
on_run_pressed                         (GtkButton       *button,
                                        gpointer         user_data)
{
}


void
on_run_released                        (GtkButton       *button,
                                        gpointer         user_data)
{
}


void
on_run_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
 /* Meglio controllare se ve ne fosse un altro
  * e in quel caso lo faccio fuori (toggled)
  */
 if(Timer != 0)
 {
  gtk_timeout_remove(Timer);
  Timer = 0;

  /* Vai di testo senza controllo di puntatori che ti fa bene ! */ 
  gtk_text_insert (GTK_TEXT ( lookup_widget(Base, "testo") ), 
                   gdk_fontset_load("*fixed*") , NULL, NULL, 
                   "\n\n -= Stop the penguins race =-", -1);
 } 
 else
 {
  /* Vai di testo senza controllo di puntatori che ti fa bene ! */ 
  gtk_text_insert (GTK_TEXT ( lookup_widget(Base, "testo") ), 
                   gdk_fontset_load("*fixed*") , NULL, NULL, 
                   "\n\n -= Start the penguins race =-", -1);

  /* A long jurney always begin with a little step */
  if(dir == FOWD)
   on_step_pressed(NULL, NULL);
  else
   on_back_pressed(NULL, NULL);

  /* Aggiungo un timer per la gestione dei pinguini */
  if(dir == FOWD)
   Timer = gtk_timeout_add( (guint32)Freq, (GtkFunction)on_step_pressed, NULL );      
  else
   Timer = gtk_timeout_add( (guint32)Freq, (GtkFunction)on_back_pressed, NULL );      
 }                  
 
 return;
}


gboolean
on_frequenza_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
 int freq, fold;

 fold = (int) (GTK_HSCALE(widget)->scale).range.old_value;
 freq = (int) (GTK_HSCALE(widget)->scale).range.adjustment->value;
 g_print("\n speed=%d,%d", freq, fold);

 if(fold != freq || !event)
 {
  freq = (10-freq); 
  Freq = 1 << freq;
  g_print(" -> T=%d ms",Freq);
  if(Timer) 
  {
   /* Rialza il bottone e il segnale di toggle ferma il timer */
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON ( lookup_widget(Base, "run") ), FALSE); 
   
   /* Abbassa il bottone e il segnale di toggle riavvia il timer */
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON ( lookup_widget(Base, "run") ), TRUE); 
  }
 }
 return FALSE;
}



void
on_frequenza_drag_leave                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        guint            time,
                                        gpointer         user_data)
{

}

